angular.module('beamng.apps')
.directive('adjustableFastMotion', ['bngApi', function (bngApi) {
  return {
	template:
	  '<div class="bngApp">' +
	    '<h2 align="center" id="fastmoCount">100%<h2>' +
	    '<md-slider flex step=1 min=100 max=1000 ng-model="slowmoslide" aria-label="_" style="padding: 0 5px"></md-slider>' +
	  '</div>',
    replace: true,
    restrict: 'EA',
	controller: ['$scope', function ($scope) {
	    $scope.slowmoslide = 100; //Set initial value to 100%
}],
	
    link: function (scope, element, attrs) {
	  scope.$watch('slowmoslide', function (newVal, oldVal) {
		  document.getElementById("fastmoCount").innerHTML = newVal + "%";
		  bngApi.engineLua( 'be:setSimulationTimeScale('+ (newVal.toString()/100) + ')' );
		  if(newVal == 100) {
			  bngApi.activeObjectLua( 'ui_message("' + ("SuperSpeed", 5, "Realtime") + '")' );
		  }
		  if(newVal > 100) {
			  bngApi.activeObjectLua( 'ui_message("' + ("SuperSpeed", 5, "Simulating game at " + newVal.toString() + "% speed") + '")' );
		  }
	  });
    }
  };
}]);